#ifndef TESTIMAGETEMPLATE_H_
#define TESTIMAGETEMPLATE_H_

#include <cxxtest/TestSuite.h>

#include "ImageTemplate.h"
#include "RGBPixel.h"
#include "GrayPixel.h"

class TestImageTemplate : public CxxTest::TestSuite
{
public:
	void testImageTemplate1() {
		ImageTemplate<RGBPixel>* anImage = new ImageTemplate<RGBPixel>(10, 10);
		RGBPixel aRGBPixel(10, 5, 23);
		bool result = anImage->setPixel(1, 2, aRGBPixel);
		TS_ASSERT( result == true );
		TS_ASSERT(aRGBPixel == anImage->getPixel(1, 2));
		delete anImage;

	}

	void testImageTeamplate2() {
		ImageTemplate<GrayPixel>* aGrayImage = new ImageTemplate<GrayPixel>(5, 5);
		GrayPixel aGrayPixel(34);
		GrayPixel anotherGray(56);
		bool result = aGrayImage->setPixel(2, 3, aGrayPixel);
		TS_ASSERT( result == true );
		TS_ASSERT(aGrayImage->getPixel(2, 3) == aGrayPixel);
		aGrayImage->setPixel(3, 4, anotherGray);
		TS_ASSERT(aGrayImage->getPixel(3, 4) == anotherGray);
		delete aGrayImage;
	}


};

#endif /*TESTIMAGETEMPLATE_H_*/
